## mingw-w64-openblas-0.3.26-1.src.tar.zst

=== kernel/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR})

# Makefile
function (build_core TARGET_CORE KDIR TSUFFIX KERNEL_DEFINITIONS)
    set (OPENBLAS_SRC "")
    set (ARCH_SUFFIX "")
    include("${PROJECT_SOURCE_DIR}/cmake/kernel.cmake")
    if (${DYNAMIC_ARCH})
        include("${PROJECT_SOURCE_DIR}/cmake/system.cmake")
    endif ()
    ParseMakefileVars("${KERNELDIR}/KERNEL")
    ParseMakefileVars("${KERNELDIR}/KERNEL.${TARGET_CORE}")
    SetDefaultL1()
    SetDefaultL2()
    SetDefaultL3()

    set(KERNEL_INTERFACE common_level1.h common_level2.h common_level3.h)
    if(NOT NO_LAPACK)
        set(KERNEL_INTERFACE ${KERNEL_INTERFACE} common_lapack.h)
    endif ()

    if (${ADD_COMMONOBJS})
        if (X86)
        if (NOT "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")
          GenerateNamedObjects("${KERNELDIR}/cpuid.S" "" "" false "" "" true)
        else()
          GenerateNamedObjects("${KERNELDIR}/cpuid_win.c" "" "" false "" "" true)
        endif()
        endif ()

        # don't use float type name mangling here
        GenerateNamedObjects("${KERNELDIR}/${LSAME_KERNEL}" "F_INTERFACE" "lsame" false "" "" true "")
        GenerateNamedObjects("${KERNELDIR}/${SCABS_KERNEL}" "COMPLEX;F_INTERFACE" "scabs1" false "" "" true "")
        GenerateNamedObjects("${KERNELDIR}/${DCABS_KERNEL}" "DOUBLE;COMPLEX;F_INTERFACE" "dcabs1" false "" "" true "")
    endif ()

    # Run with no ARCH_SUFFIX for above
    set (ARCH_SUFFIX "${TSUFFIX}")
    # Makefile.L1
    foreach (float_type ${FLOAT_TYPES})
      # a bit of metaprogramming here to pull out the appropriate KERNEL var
      string(SUBSTRING ${float_type} 0 1 float_char)
      if (${float_type} STREQUAL "BFLOAT16")
	set (float_char "SB")
      endif ()
      GenerateNamedObjects("${KERNELDIR}/${${float_char}AMAXKERNEL}" "USE_ABS" "amax_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}AMINKERNEL}" "USE_ABS;USE_MIN" "amin_k" false "" "" false ${float_type})
      if (DEFINED ${float_char}MAXKERNEL)
        GenerateNamedObjects("${KERNELDIR}/${${float_char}MAXKERNEL}" "" "max_k" false "" "" false ${float_type})
      endif ()
      if (DEFINED ${float_char}MINKERNEL)
        GenerateNamedObjects("${KERNELDIR}/${${float_char}MINKERNEL}" "USE_MIN" "min_k" false "" "" false ${float_type})
      endif ()
      GenerateNamedObjects("${KERNELDIR}/${I${float_char}AMAXKERNEL}" "USE_ABS" "i*amax_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${I${float_char}AMINKERNEL}" "USE_ABS;USE_MIN" "i*amin_k" false "" "" false ${float_type})
      if (DEFINED I${float_char}MAXKERNEL)
        GenerateNamedObjects("${KERNELDIR}/${I${float_char}MAXKERNEL}" "" "i*max_k" false "" "" false ${float_type})
      endif ()
      if (DEFINED I${float_char}MINKERNEL)
        GenerateNamedObjects("${KERNELDIR}/${I${float_char}MINKERNEL}" "USE_MIN" "i*min_k" false "" "" false ${float_type})
      endif ()
      GenerateNamedObjects("${KERNELDIR}/${${float_char}ASUMKERNEL}" "" "asum_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}AXPYKERNEL}" "" "axpy_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}COPYKERNEL}" "C_INTERFACE" "copy_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}NRM2KERNEL}" "" "nrm2_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}ROTKERNEL}" "" "rot_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}SCALKERNEL}" "" "scal_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}SWAPKERNEL}" "" "swap_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}AXPBYKERNEL}" "" "axpby_k" false "" "" false ${float_type})
      GenerateNamedObjects("${KERNELDIR}/${${float_char}SUMKERNEL}" "" "sum_k" false "" "" false ${float_type})

      if (${float_type} STREQUAL "COMPLEX" OR ${float_type} STREQUAL "ZCOMPLEX")
        GenerateNamedObjects("${KERNELDIR}/${${float_char}AXPYKERNEL}" "CONJ" "axpyc_k" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}DOTKERNEL}" "" "dotu_k" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}DOTKERNEL}" "CONJ" "dotc_k" false "" "" false ${float_type})
      else ()
        GenerateNamedObjects("${KERNELDIR}/${${float_char}DOTKERNEL}" "" "dot_k" false "" "" false ${float_type})
      endif ()

      if (${float_type} STREQUAL "COMPLEX")
      GenerateNamedObjects("${KERNELDIR}/${${float_char}ROTKERNEL}" "" "srot_k" false "" "" false ${float_type})
      endif()
      if (${float_type} STREQUAL "ZCOMPLEX")
      GenerateNamedObjects("${KERNELDIR}/${${float_char}ROTKERNEL}" "" "drot_k" false "" "" false ${float_type})
      endif()

    endforeach ()

    #dsdot,sdsdot
    GenerateNamedObjects("${KERNELDIR}/${DSDOTKERNEL}" "DSDOT" "d*dot_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${DSDOTKERNEL}" "DSDOT" "dsdot_k" false "" "" false "SINGLE")

    # sbdot
    if (BUILD_BFLOAT16)
	    GenerateNamedObjects("${KERNELDIR}/${SBDOTKERNEL}" "SBDOT" "dot_k" false "" "" false "BFLOAT16")
	    GenerateNamedObjects("${KERNELDIR}/${BF16TOKERNEL}" "SINGLE" "f16tos_k" false "" "" false "BFLOAT16")
	    GenerateNamedObjects("${KERNELDIR}/${BF16TOKERNEL}" "DOUBLE" "bf16tod_k" false "" "" false "DOUBLE")
	    GenerateNamedObjects("${KERNELDIR}/${TOBF16KERNEL}" "SINGLE" "stobf16_k" false "" "" false "BFLOAT16")
	    GenerateNamedObjects("${KERNELDIR}/${TOBF16KERNEL}" "DOUBLE" "dtobf16_k" false "" "" false "BFLOAT16")
    endif()

    if ((BUILD_COMPLEX OR BUILD_DOUBLE)  AND NOT BUILD_SINGLE)
    GenerateNamedObjects("${KERNELDIR}/${SAMAXKERNEL}" "USE_ABS" "amax_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SAMINKERNEL}" "USE_ABS;USE_MIN" "amin_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SASUMKERNEL}" "" "asum_k" false "" "" false "SINGLE")
    if (DEFINED SMAXKERNEL)
	      GenerateNamedObjects("${KERNELDIR}/${SMAXKERNEL}" "" "max_k" false "" "" false "SINGLE")
    endif ()
    if (DEFINED SMINKERNEL)
	      GenerateNamedObjects("${KERNELDIR}/${SMINKERNEL}" "USE_MIN" "min_k" false "" "" false "SINGLE")
    endif ()
    if (DEFINED ISMINKERNEL)
	    GenerateNamedObjects("${KERNELDIR}/${ISMINKERNEL}" "USE_MIN" "i*min_k" false "" "" false "SINGLE")
    endif ()
    if (DEFINED ISMAXKERNEL)
	      GenerateNamedObjects("${KERNELDIR}/${ISMAXKERNEL}" "" "i*max_k" false "" "" false "SINGLE")
    endif ()
    GenerateNamedObjects("${KERNELDIR}/${ISAMAXKERNEL}" "USE_ABS" "i*amax_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${ISAMINKERNEL}" "USE_ABS;USE_MIN" "i*amin_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SSCALKERNEL}" "" "scal_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SCOPYKERNEL}" "C_INTERFACE" "copy_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SSWAPKERNEL}" "" "swap_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SAXPYKERNEL}" "" "axpy_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SNRM2KERNEL}" "" "nrm2_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SDOTKERNEL}" "" "dot_k" false "" "" false "SINGLE")
    GenerateNamedObjects("${KERNELDIR}/${SROTKERNEL}" "" "rot_k" false "" "" false "SINGLE")
    endif ()
    if (BUILD_COMPLEX16  AND NOT BUILD_DOUBLE)
	    GenerateNamedObjects("${KERNELDIR}/${DAMAXKERNEL}" "USE_ABS" "amax_k" false "" "" false "DOUBLE")
	    GenerateNamedObjects("${KERNELDIR}/${DAMINKERNEL}" "USE_ABS;USE_MIN" "amin_k" false "" "" false "DOUBLE")
	    GenerateNamedObjects("${KERNELDIR}/${DASUMKERNEL}" "" "asum_k" false "" "" false "DOUBLE")
    if (DEFINED DMAXKERNEL)
	    GenerateNamedObjects("${KERNELDIR}/${DMAXKERNEL}" "" "max_k" false "" "" false "DOUBLE")
    endif ()
    if (DEFINED DMINKERNEL)
	    GenerateNamedObjects("${KERNELDIR}/${DMINKERNEL}" "USE_MIN" "min_k" false "" "" false "DOUBLE")
    endif ()
    if (DEFINED IDMINKERNEL)
	    GenerateNamedObjects("${KERNELDIR}/${IDMINKERNEL}" "USE_MIN" "i*min_k" false "" "" false "DOUBLE")
    endif ()
    if (DEFINED IDMAXKERNEL)
	    GenerateNamedObjects("${KERNELDIR}/${IDMAXKERNEL}" "" "i*max_k" false "" "" false "DOUBLE")
    endif ()
    GenerateNamedObjects("${KERNELDIR}/${IDAMAXKERNEL}" "USE_ABS" "i*amax_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${IDAMINKERNEL}" "USE_ABS;USE_MIN" "i*amin_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DSCALKERNEL}" "" "scal_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DCOPYKERNEL}" "C_INTERFACE" "copy_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DNRM2KERNEL}" "" "nrm2_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DROTKERNEL}" "" "rot_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DDOTKERNEL}" "" "dot_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DSWAPKERNEL}" "" "swap_k" false "" "" false "DOUBLE")
    GenerateNamedObjects("${KERNELDIR}/${DAXPYKERNEL}" "" "axpy_k" false "" "" false "DOUBLE")
    endif ()

    # Makefile.L2
    GenerateCombinationObjects("generic/symv_k.c" "LOWER" "U" "" 1 "" "" 3)
    GenerateNamedObjects("generic/ger.c" "" "ger_k" false "" "" "" 3)
    foreach (float_type ${FLOAT_TYPES})
      string(SUBSTRING ${float_type} 0 1 float_char)
      if (${float_type} STREQUAL "COMPLEX" OR ${float_type} STREQUAL "ZCOMPLEX")
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GERUKERNEL}" "" "geru_k" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GERCKERNEL}" "CONJ" "gerc_k" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GERUKERNEL}" "XCONJ" "gerv_k" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GERCKERNEL}" "CONJ;XCONJ" "gerd_k" false "" "" false ${float_type})

        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVNKERNEL}" "" "gemv_n" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVTKERNEL}" "TRANSA" "gemv_t" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVNKERNEL}" "CONJ" "gemv_r" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVTKERNEL}" "CONJ;TRANSA" "gemv_c" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVNKERNEL}" "XCONJ" "gemv_o" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVTKERNEL}" "XCONJ;TRANSA" "gemv_u" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVNKERNEL}" "XCONJ;CONJ" "gemv_s" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVTKERNEL}" "XCONJ;CONJ;TRANSA" "gemv_d" false "" "" false ${float_type})

        GenerateNamedObjects("${KERNELDIR}/${${float_char}HEMV_U_KERNEL}" "HEMV" "hemv_U" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}HEMV_L_KERNEL}" "HEMV;LOWER" "hemv_L" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}HEMV_V_KERNEL}" "HEMV;HEMVREV" "hemv_V" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}HEMV_M_KERNEL}" "HEMV;HEMVREV;LOWER" "hemv_M" false "" "" false ${float_type})

      else ()
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVNKERNEL}" "" "gemv_n" false "" "" false ${float_type})
        GenerateNamedObjects("${KERNELDIR}/${${float_char}GEMVTKERNEL}" "TRANS" "gemv_t" false "" "" false ${float_type})
      endif ()

=== lapack-netlib/LAPACKE/mangling/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(MANGLING C Fortran)

add_executable(xintface Fintface.f Cintface.c)

=== lapack-netlib/LAPACKE/src/Makefile ===
##############################################################################
# Copyright (c) 2014, Intel Corp.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of Intel Corporation nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################
# Contents: Native C interface to LAPACK
# Author: Intel Corporation
##############################################################################
# makefile for LAPACKE, used to build lapacke binary.
#
# Note: we use multiple OBJ_S, OBJ_C, etc, instead of a single OBJ
# to allow build with mingw (argument list too long for the msys ar)
#
TOPSRCDIR = ../..
include $(TOPSRCDIR)/make.inc

.SUFFIXES: .c .o
.c.o:
	$(CC) $(CFLAGS) -I../include -c -o $@ $<

OBJ = \
lapacke_ilaver.o \
lapacke_nancheck.o

ifeq ($(BUILD_COMPLEX),1)
OBJ_C = \
lapacke_cbbcsd.o \
lapacke_cbbcsd_work.o \
lapacke_cbdsqr.o \
lapacke_cbdsqr_work.o \
lapacke_cgbbrd.o \
lapacke_cgbbrd_work.o \
lapacke_cgbcon.o \
lapacke_cgbcon_work.o \
lapacke_cgbequ.o \
lapacke_cgbequ_work.o \
lapacke_cgbequb.o \
lapacke_cgbequb_work.o \
lapacke_cgbrfs.o \
lapacke_cgbrfs_work.o \
lapacke_cgbsv.o \
lapacke_cgbsv_work.o \
lapacke_cgbsvx.o \
lapacke_cgbsvx_work.o \
lapacke_cgbtrf.o \
lapacke_cgbtrf_work.o \
lapacke_cgbtrs.o \
lapacke_cgbtrs_work.o \
lapacke_cgebak.o \
lapacke_cgebak_work.o \
lapacke_cgebal.o \
lapacke_cgebal_work.o \
lapacke_cgebrd.o \
lapacke_cgebrd_work.o \
lapacke_cgecon.o \
lapacke_cgecon_work.o \
lapacke_cgeequ.o \
lapacke_cgeequ_work.o \
lapacke_cgeequb.o \
lapacke_cgeequb_work.o \
lapacke_cgees.o \
lapacke_cgees_work.o \
lapacke_cgeesx.o \
lapacke_cgeesx_work.o \
lapacke_cgeev.o \
lapacke_cgeev_work.o \
lapacke_cgeevx.o \
lapacke_cgeevx_work.o \
lapacke_cgehrd.o \
lapacke_cgehrd_work.o \
lapacke_cgejsv.o \
lapacke_cgejsv_work.o \
lapacke_cgelq.o \
lapacke_cgelq_work.o \
lapacke_cgelq2.o \
lapacke_cgelq2_work.o \
lapacke_cgelqf.o \
lapacke_cgelqf_work.o \
lapacke_cgels.o \
lapacke_cgels_work.o \
lapacke_cgelsd.o \
lapacke_cgelsd_work.o \
lapacke_cgelss.o \
lapacke_cgelss_work.o \
lapacke_cgelsy.o \
lapacke_cgelsy_work.o \
lapacke_cgemlq.o \
lapacke_cgemlq_work.o \
lapacke_cgemqr.o \
lapacke_cgemqr_work.o \
lapacke_cgemqrt.o \
lapacke_cgemqrt_work.o \
lapacke_cgeqlf.o \
lapacke_cgeqlf_work.o \
lapacke_cgeqp3.o \
lapacke_cgeqp3_work.o \
lapacke_cgeqr.o \
lapacke_cgeqr_work.o \
lapacke_cgeqr2.o \
lapacke_cgeqr2_work.o \
lapacke_cgeqrf.o \
lapacke_cgeqrf_work.o \
lapacke_cgeqrfp.o \
lapacke_cgeqrfp_work.o \
lapacke_cgeqrt.o \
lapacke_cgeqrt_work.o \
lapacke_cgeqrt2.o \
lapacke_cgeqrt2_work.o \
lapacke_cgeqrt3.o \
lapacke_cgeqrt3_work.o \
lapacke_cgerfs.o \
lapacke_cgerfs_work.o \
lapacke_cgerqf.o \
lapacke_cgerqf_work.o \
lapacke_cgesdd.o \
lapacke_cgesdd_work.o \
lapacke_cgedmd.o \
lapacke_cgedmd_work.o \
lapacke_cgedmdq.o \
lapacke_cgedmdq_work.o \
lapacke_cgesv.o \
lapacke_cgesv_work.o \
lapacke_cgesvd.o \
lapacke_cgesvd_work.o \
lapacke_cgesvdq.o \
lapacke_cgesvdq_work.o \
lapacke_cgesvdx.o \
lapacke_cgesvdx_work.o \
lapacke_cgesvj.o \
lapacke_cgesvj_work.o \
lapacke_cgesvx.o \
lapacke_cgesvx_work.o \
lapacke_cgetf2.o \
lapacke_cgetf2_work.o \
lapacke_cgetrf.o \
lapacke_cgetrf_work.o \
lapacke_cgetrf2.o \
lapacke_cgetrf2_work.o \
lapacke_cgetri.o \
lapacke_cgetri_work.o \
lapacke_cgetrs.o \
lapacke_cgetrs_work.o \
lapacke_cgetsls.o \
lapacke_cgetsls_work.o \
lapacke_cgetsqrhrt.o \
lapacke_cgetsqrhrt_work.o \
lapacke_cggbak.o \
lapacke_cggbak_work.o \
lapacke_cggbal.o \
lapacke_cggbal_work.o \
lapacke_cgges.o \
lapacke_cgges_work.o \
lapacke_cgges3.o \
lapacke_cgges3_work.o \
lapacke_cggesx.o \
lapacke_cggesx_work.o \
lapacke_cggev.o \
lapacke_cggev_work.o \
lapacke_cggev3.o \
lapacke_cggev3_work.o \
lapacke_cggevx.o \
lapacke_cggevx_work.o \
lapacke_cggglm.o \
lapacke_cggglm_work.o \
lapacke_cgghd3.o \
lapacke_cgghd3_work.o \
lapacke_cgghrd.o \
lapacke_cgghrd_work.o \
lapacke_cgglse.o \
lapacke_cgglse_work.o \
lapacke_cggqrf.o \
lapacke_cggqrf_work.o \
lapacke_cggrqf.o \
lapacke_cggrqf_work.o \
lapacke_cggsvd3.o \
lapacke_cggsvd3_work.o \
lapacke_cggsvp3.o \
lapacke_cggsvp3_work.o \
lapacke_cgtcon.o \
lapacke_cgtcon_work.o \
lapacke_cgtrfs.o \
lapacke_cgtrfs_work.o \
lapacke_cgtsv.o \
lapacke_cgtsv_work.o \
lapacke_cgtsvx.o \
lapacke_cgtsvx_work.o \
lapacke_cgttrf.o \
lapacke_cgttrf_work.o \
lapacke_cgttrs.o \
lapacke_cgttrs_work.o \
lapacke_chbev.o \
lapacke_chbev_work.o \
lapacke_chbev_2stage.o \
lapacke_chbev_2stage_work.o \
lapacke_chbevd.o \
lapacke_chbevd_work.o \
lapacke_chbevd_2stage.o \
lapacke_chbevd_2stage_work.o \
lapacke_chbevx.o \
lapacke_chbevx_work.o \
lapacke_chbevx_2stage.o \
lapacke_chbevx_2stage_work.o \
lapacke_chbgst.o \
lapacke_chbgst_work.o \
lapacke_chbgv.o \
lapacke_chbgv_work.o \
lapacke_chbgvd.o \
lapacke_chbgvd_work.o \
lapacke_chbgvx.o \
lapacke_chbgvx_work.o \
lapacke_chbtrd.o \
lapacke_chbtrd_work.o \
lapacke_checon.o \
lapacke_checon_work.o \
lapacke_checon_3.o \
lapacke_checon_3_work.o \
lapacke_cheequb.o \
lapacke_cheequb_work.o \
lapacke_cheev.o \
lapacke_cheev_work.o \
lapacke_cheev_2stage.o \
lapacke_cheev_2stage_work.o \
lapacke_cheevd.o \
lapacke_cheevd_work.o \
lapacke_cheevd_2stage.o \
lapacke_cheevd_2stage_work.o \
lapacke_cheevr.o \
lapacke_cheevr_work.o \
lapacke_cheevr_2stage.o \
lapacke_cheevr_2stage_work.o \
lapacke_cheevx.o \
lapacke_cheevx_work.o \
lapacke_cheevx_2stage.o \
lapacke_cheevx_2stage_work.o \
lapacke_chegst.o \
lapacke_chegst_work.o \
lapacke_chegv.o \
lapacke_chegv_work.o \
lapacke_chegv_2stage.o \
lapacke_chegv_2stage_work.o \
lapacke_chegvd.o \
lapacke_chegvd_work.o \
lapacke_chegvx.o \
lapacke_chegvx_work.o \
lapacke_cherfs.o \
lapacke_cherfs_work.o \
lapacke_chesv.o \
lapacke_chesv_work.o \
lapacke_chesv_aa.o \
lapacke_chesv_aa_work.o \
lapacke_chesv_aa_2stage.o \
lapacke_chesv_aa_2stage_work.o \
lapacke_chesv_rk.o \
lapacke_chesv_rk_work.o \
lapacke_chesvx.o \
lapacke_chesvx_work.o \
lapacke_cheswapr.o \
lapacke_cheswapr_work.o \
lapacke_chetrd.o \
lapacke_chetrd_work.o \
lapacke_chetrf.o \
lapacke_chetrf_work.o \
lapacke_chetrf_aa.o \
lapacke_chetrf_aa_work.o \
lapacke_chetrf_aa_2stage.o \
lapacke_chetrf_aa_2stage_work.o \
lapacke_chetrf_rk.o \
lapacke_chetrf_rk_work.o \
lapacke_chetrf_rook.o \
lapacke_chetrf_rook_work.o \
lapacke_chetri.o \
lapacke_chetri_work.o \
lapacke_chetri2.o \
lapacke_chetri2_work.o \
lapacke_chetri2x.o \
lapacke_chetri2x_work.o \
lapacke_chetri_3.o \
lapacke_chetri_3_work.o \
lapacke_chetrs.o \
lapacke_chetrs_work.o \
lapacke_chetrs2.o \
lapacke_chetrs2_work.o \
lapacke_chetrs_3.o \
lapacke_chetrs_3_work.o \
lapacke_chetrs_aa.o \
lapacke_chetrs_aa_work.o \
lapacke_chetrs_aa_2stage.o \
lapacke_chetrs_aa_2stage_work.o \
lapacke_chetrs_rook.o \
lapacke_chetrs_rook_work.o \
lapacke_chfrk.o \
lapacke_chfrk_work.o \
lapacke_chgeqz.o \
lapacke_chgeqz_work.o \
lapacke_chpcon.o \
lapacke_chpcon_work.o \
lapacke_chpev.o \
lapacke_chpev_work.o \
lapacke_chpevd.o \
lapacke_chpevd_work.o \
lapacke_chpevx.o \
lapacke_chpevx_work.o \
lapacke_chpgst.o \
lapacke_chpgst_work.o \
lapacke_chpgv.o \
lapacke_chpgv_work.o \
lapacke_chpgvd.o \
lapacke_chpgvd_work.o \
lapacke_chpgvx.o \
lapacke_chpgvx_work.o \
lapacke_chprfs.o \
lapacke_chprfs_work.o \
lapacke_chpsv.o \
lapacke_chpsv_work.o \
lapacke_chpsvx.o \
lapacke_chpsvx_work.o \
lapacke_chptrd.o \
lapacke_chptrd_work.o \
lapacke_chptrf.o \
lapacke_chptrf_work.o \
lapacke_chptri.o \
lapacke_chptri_work.o \
lapacke_chptrs.o \
lapacke_chptrs_work.o \
lapacke_chsein.o \
lapacke_chsein_work.o \
lapacke_chseqr.o \
lapacke_chseqr_work.o \
lapacke_clacgv.o \
lapacke_clacgv_work.o \
lapacke_clacn2.o \
lapacke_clacn2_work.o \
lapacke_clacp2.o \
lapacke_clacp2_work.o \
lapacke_clacpy.o \
lapacke_clacpy_work.o \
lapacke_clacrm.o \
lapacke_clacrm_work.o \
lapacke_clag2z.o \
lapacke_clag2z_work.o \
lapacke_clangb.o \
lapacke_clangb_work.o \
lapacke_clange.o \
lapacke_clange_work.o \
lapacke_clanhe.o \
lapacke_clanhe_work.o \
lapacke_clansy.o \
lapacke_clansy_work.o \
lapacke_clantr.o \
lapacke_clantr_work.o \
lapacke_clapmr.o \
lapacke_clapmr_work.o \
lapacke_clapmt.o \
lapacke_clapmt_work.o \
lapacke_clarcm.o \
lapacke_clarcm_work.o \
lapacke_clarfb.o \
lapacke_clarfb_work.o \
lapacke_clarfg.o \
lapacke_clarfg_work.o \
lapacke_clarft.o \
lapacke_clarft_work.o \
lapacke_clarfx.o \
lapacke_clarfx_work.o \
lapacke_clarnv.o \
lapacke_clarnv_work.o \
lapacke_clascl.o \
lapacke_clascl_work.o \
lapacke_claset.o \
lapacke_claset_work.o \
lapacke_classq.o \
lapacke_classq_work.o \
lapacke_claswp.o \
lapacke_claswp_work.o \
lapacke_clauum.o \
lapacke_clauum_work.o \
lapacke_cpbcon.o \
lapacke_cpbcon_work.o \
lapacke_cpbequ.o \
lapacke_cpbequ_work.o \
lapacke_cpbrfs.o \
lapacke_cpbrfs_work.o \
lapacke_cpbstf.o \
lapacke_cpbstf_work.o \
lapacke_cpbsv.o \
lapacke_cpbsv_work.o \
lapacke_cpbsvx.o \
lapacke_cpbsvx_work.o \
lapacke_cpbtrf.o \
lapacke_cpbtrf_work.o \
lapacke_cpbtrs.o \
lapacke_cpbtrs_work.o \
lapacke_cpftrf.o \
lapacke_cpftrf_work.o \
lapacke_cpftri.o \
lapacke_cpftri_work.o \
lapacke_cpftrs.o \
lapacke_cpftrs_work.o \
lapacke_cpocon.o \
lapacke_cpocon_work.o \
lapacke_cpoequ.o \
lapacke_cpoequ_work.o \
lapacke_cpoequb.o \
lapacke_cpoequb_work.o \
lapacke_cporfs.o \
lapacke_cporfs_work.o \
lapacke_cposv.o \
lapacke_cposv_work.o \
lapacke_cposvx.o \
lapacke_cposvx_work.o \
lapacke_cpotrf.o \
lapacke_cpotrf_work.o \
lapacke_cpotrf2.o \
lapacke_cpotrf2_work.o \
lapacke_cpotri.o \
lapacke_cpotri_work.o \
lapacke_cpotrs.o \
lapacke_cpotrs_work.o \
lapacke_cppcon.o \
lapacke_cppcon_work.o \
lapacke_cppequ.o \
lapacke_cppequ_work.o \
lapacke_cpprfs.o \
lapacke_cpprfs_work.o \
lapacke_cppsv.o \
lapacke_cppsv_work.o \
lapacke_cppsvx.o \
lapacke_cppsvx_work.o \
lapacke_cpptrf.o \
lapacke_cpptrf_work.o \
lapacke_cpptri.o \
lapacke_cpptri_work.o \
lapacke_cpptrs.o \
lapacke_cpptrs_work.o \
lapacke_cpstrf.o \
lapacke_cpstrf_work.o \
lapacke_cptcon.o \
lapacke_cptcon_work.o \
lapacke_cpteqr.o \
lapacke_cpteqr_work.o \
lapacke_cptrfs.o \
lapacke_cptrfs_work.o \
lapacke_cptsv.o \
lapacke_cptsv_work.o \
lapacke_cptsvx.o \
lapacke_cptsvx_work.o \
lapacke_cpttrf.o \
lapacke_cpttrf_work.o \
lapacke_cpttrs.o \
lapacke_cpttrs_work.o \
lapacke_cspcon.o \
lapacke_cspcon_work.o \
lapacke_csprfs.o \
lapacke_csprfs_work.o \
lapacke_cspsv.o \
lapacke_cspsv_work.o \
lapacke_cspsvx.o \
lapacke_cspsvx_work.o \
lapacke_csptrf.o \
lapacke_csptrf_work.o \
lapacke_csptri.o \
lapacke_csptri_work.o \
lapacke_csptrs.o \
lapacke_csptrs_work.o \
lapacke_cstedc.o \
lapacke_cstedc_work.o \
lapacke_cstegr.o \
lapacke_cstegr_work.o \
lapacke_cstein.o \

=== lapack-netlib/TESTING/LIN/CMakeLists.txt ===
set(ALINTST
   aladhd.f alaerh.f alaesm.f alahd.f alareq.f
   alasum.f alasvm.f chkxer.f icopy.f ilaenv.f xlaenv.f xerbla.f)

set(SCLNTST slaord.f)

set(DZLNTST dlaord.f)

set(SLINTST schkaa.F
   schkeq.f schkgb.f schkge.f schkgt.f
   schklq.f schkpb.f schkpo.f schkps.f schkpp.f
   schkpt.f schkq3.f schkqp3rk.f schkql.f schkqr.f schkrq.f
   schksp.f schksy.f schksy_rook.f schksy_rk.f 
   schksy_aa.f schksy_aa_2stage.f 
   schktb.f schktp.f schktr.f
   schktz.f
   sdrvgt.f sdrvls.f sdrvpb.f
   sdrvpp.f sdrvpt.f sdrvsp.f sdrvsy_rook.f sdrvsy_rk.f 
   sdrvsy_aa.f sdrvsy_aa_2stage.f
   serrgt.f serrlq.f serrls.f
   serrps.f serrql.f serrqp.f serrqr.f
   serrrq.f serrtr.f serrtz.f
   sgbt01.f sgbt02.f sgbt05.f sgeqls.f
   sgerqs.f sget01.f sget02.f
   sget03.f sget04.f sget06.f sget07.f sgtt01.f sgtt02.f
   sgtt05.f slaptm.f slarhs.f slatb4.f slatb5.f slattb.f slattp.f
   slattr.f slavsp.f slavsy.f slavsy_rook.f slqt01.f slqt02.f
   slqt03.f spbt01.f spbt02.f spbt05.f spot01.f
   spot02.f spot03.f spot05.f spst01.f sppt01.f
   sppt02.f sppt03.f sppt05.f sptt01.f sptt02.f
   sptt05.f sqlt01.f sqlt02.f sqlt03.f sqpt01.f
   sqrt01.f sqrt01p.f sqrt02.f sqrt03.f sqrt11.f sqrt12.f
   sqrt13.f sqrt14.f sqrt15.f sqrt16.f sqrt17.f
   srqt01.f srqt02.f srqt03.f srzt01.f srzt02.f
   sspt01.f ssyt01.f ssyt01_rook.f ssyt01_3.f 
   ssyt01_aa.f
   stbt02.f stbt03.f stbt05.f stbt06.f stpt01.f
   stpt02.f stpt03.f stpt05.f stpt06.f strt01.f
   strt02.f strt03.f strt05.f strt06.f
   sgennd.f sqrt04.f sqrt05.f schkqrt.f serrqrt.f schkqrtp.f serrqrtp.f
   schklqt.f schklqtp.f schktsqr.f
   serrlqt.f serrlqtp.f serrtsqr.f stsqr01.f slqt04.f slqt05.f
   schkorhr_col.f serrorhr_col.f sorhr_col01.f sorhr_col02.f)

if(USE_XBLAS)
  list(APPEND SLINTST sdrvgbx.f sdrvgex.f sdrvsyx.f sdrvpox.f
                      serrvxx.f serrgex.f serrsyx.f serrpox.f
                      sebchvxx.f)
else()
  list(APPEND SLINTST sdrvgb.f sdrvge.f sdrvsy.f sdrvpo.f
                      serrvx.f serrge.f serrsy.f serrpo.f)
endif()

set(CLINTST cchkaa.F
   cchkeq.f cchkgb.f cchkge.f cchkgt.f
   cchkhe.f cchkhe_rook.f cchkhe_rk.f 
   cchkhe_aa.f cchkhe_aa_2stage.f
   cchkhp.f cchklq.f cchkpb.f
   cchkpo.f cchkps.f cchkpp.f cchkpt.f cchkq3.f cchkqp3rk.f cchkql.f
   cchkqr.f cchkrq.f cchksp.f cchksy.f cchksy_rook.f cchksy_rk.f
   cchksy_aa.f cchksy_aa_2stage.f
   cchktb.f
   cchktp.f cchktr.f cchktz.f
   cdrvgt.f cdrvhe_rook.f cdrvhe_rk.f 
   cdrvhe_aa.f cdrvhe_aa_2stage.f cdrvsy_aa_2stage.f
   cdrvhp.f
   cdrvls.f cdrvpb.f cdrvpp.f cdrvpt.f
   cdrvsp.f cdrvsy_rook.f cdrvsy_rk.f 
   cdrvsy_aa.f 
   cerrgt.f cerrlq.f
   cerrls.f cerrps.f cerrql.f cerrqp.f
   cerrqr.f cerrrq.f cerrtr.f cerrtz.f
   cgbt01.f cgbt02.f cgbt05.f cgeqls.f
   cgerqs.f cget01.f cget02.f
   cget03.f cget04.f cget07.f cgtt01.f cgtt02.f
   cgtt05.f chet01.f chet01_rook.f chet01_3.f
   chet01_aa.f
   chpt01.f claipd.f claptm.f clarhs.f clatb4.f clatb5.f
   clatsp.f clatsy.f clattb.f clattp.f clattr.f
   clavhe.f clavhe_rook.f clavhp.f clavsp.f clavsy.f clavsy_rook.f clqt01.f
   clqt02.f clqt03.f cpbt01.f cpbt02.f cpbt05.f
   cpot01.f cpot02.f cpot03.f cpot05.f cpst01.f
   cppt01.f cppt02.f cppt03.f cppt05.f cptt01.f
   cptt02.f cptt05.f cqlt01.f cqlt02.f cqlt03.f
   cqpt01.f cqrt01.f cqrt01p.f cqrt02.f cqrt03.f cqrt11.f
   cqrt12.f cqrt13.f cqrt14.f cqrt15.f cqrt16.f
   cqrt17.f crqt01.f crqt02.f crqt03.f crzt01.f crzt02.f
   csbmv.f  cspt01.f
   cspt02.f cspt03.f csyt01.f csyt01_rook.f csyt01_3.f
   csyt01_aa.f 
   csyt02.f csyt03.f
   ctbt02.f ctbt03.f ctbt05.f ctbt06.f ctpt01.f
   ctpt02.f ctpt03.f ctpt05.f ctpt06.f ctrt01.f
   ctrt02.f ctrt03.f ctrt05.f ctrt06.f
   sget06.f cgennd.f
   cqrt04.f cqrt05.f cchkqrt.f cerrqrt.f cchkqrtp.f cerrqrtp.f
   cchklqt.f cchklqtp.f cchktsqr.f
   cerrlqt.f cerrlqtp.f cerrtsqr.f ctsqr01.f clqt04.f clqt05.f
   cchkunhr_col.f cerrunhr_col.f cunhr_col01.f cunhr_col02.f)

if(USE_XBLAS)
  list(APPEND CLINTST cdrvgbx.f cdrvgex.f cdrvhex.f cdrvsyx.f cdrvpox.f
                      cerrvxx.f cerrgex.f cerrhex.f cerrsyx.f cerrpox.f
                      cebchvxx.f)
else()
  list(APPEND CLINTST cdrvgb.f cdrvge.f cdrvhe.f cdrvsy.f cdrvpo.f
                      cerrvx.f cerrge.f cerrhe.f cerrsy.f cerrpo.f)
endif()

set(DLINTST dchkaa.F
   dchkeq.f dchkgb.f dchkge.f dchkgt.f
   dchklq.f dchkpb.f dchkpo.f dchkps.f dchkpp.f
   dchkpt.f dchkq3.f dchkqp3rk.f dchkql.f dchkqr.f dchkrq.f
   dchksp.f dchksy.f dchksy_rook.f dchksy_rk.f 
   dchksy_aa.f dchksy_aa_2stage.f
   dchktb.f dchktp.f dchktr.f
   dchktz.f
   ddrvgt.f ddrvls.f ddrvpb.f
   ddrvpp.f ddrvpt.f ddrvsp.f ddrvsy_rook.f ddrvsy_rk.f 
   ddrvsy_aa.f ddrvsy_aa_2stage.f
   derrgt.f derrlq.f derrls.f
   derrps.f derrql.f derrqp.f derrqr.f
   derrrq.f derrtr.f derrtz.f
   dgbt01.f dgbt02.f dgbt05.f dgeqls.f
   dgerqs.f dget01.f dget02.f
   dget03.f dget04.f dget06.f dget07.f dgtt01.f dgtt02.f
   dgtt05.f dlaptm.f dlarhs.f dlatb4.f dlatb5.f dlattb.f dlattp.f
   dlattr.f dlavsp.f dlavsy.f dlavsy_rook.f dlqt01.f dlqt02.f
   dlqt03.f dpbt01.f dpbt02.f dpbt05.f dpot01.f
   dpot02.f dpot03.f dpot05.f dpst01.f dppt01.f
   dppt02.f dppt03.f dppt05.f dptt01.f dptt02.f
   dptt05.f dqlt01.f dqlt02.f dqlt03.f dqpt01.f
   dqrt01.f dqrt01p.f dqrt02.f dqrt03.f dqrt11.f dqrt12.f
   dqrt13.f dqrt14.f dqrt15.f dqrt16.f dqrt17.f
   drqt01.f drqt02.f drqt03.f drzt01.f drzt02.f
   dspt01.f dsyt01.f dsyt01_rook.f dsyt01_3.f
   dsyt01_aa.f
   dtbt02.f dtbt03.f dtbt05.f dtbt06.f dtpt01.f
   dtpt02.f dtpt03.f dtpt05.f dtpt06.f dtrt01.f
   dtrt02.f dtrt03.f dtrt05.f dtrt06.f
   dgennd.f
   dqrt04.f dqrt05.f dchkqrt.f derrqrt.f dchkqrtp.f derrqrtp.f
   dchklq.f dchklqt.f dchklqtp.f dchktsqr.f
   derrlqt.f derrlqtp.f derrtsqr.f dtsqr01.f dlqt04.f dlqt05.f
   dchkorhr_col.f derrorhr_col.f dorhr_col01.f dorhr_col02.f)

if(USE_XBLAS)
  list(APPEND DLINTST ddrvgbx.f ddrvgex.f ddrvsyx.f ddrvpox.f
                      derrvxx.f derrgex.f derrsyx.f derrpox.f
                      debchvxx.f)
else()
  list(APPEND DLINTST ddrvgb.f ddrvge.f ddrvsy.f ddrvpo.f
                      derrvx.f derrge.f derrsy.f derrpo.f)
endif()

set(ZLINTST zchkaa.F
   zchkeq.f zchkgb.f zchkge.f zchkgt.f
   zchkhe.f zchkhe_rook.f zchkhe_rk.f 
   zchkhe_aa.f zchkhe_aa_2stage.f
   zchkhp.f zchklq.f zchkpb.f
   zchkpo.f zchkps.f zchkpp.f zchkpt.f zchkq3.f zchkqp3rk.f zchkql.f
   zchkqr.f zchkrq.f zchksp.f zchksy.f zchksy_rook.f zchksy_rk.f
   zchksy_aa.f  zchksy_aa_2stage.f
   zchktb.f
   zchktp.f zchktr.f zchktz.f
   zdrvgt.f zdrvhe_rook.f zdrvhe_rk.f 
   zdrvhe_aa.f  zdrvhe_aa_2stage.f
   zdrvhp.f
   zdrvls.f zdrvpb.f zdrvpp.f zdrvpt.f
   zdrvsp.f zdrvsy_rook.f zdrvsy_rk.f 
   zdrvsy_aa.f zdrvsy_aa_2stage.f 
   zerrgt.f zerrlq.f
   zerrls.f zerrps.f zerrql.f zerrqp.f
   zerrqr.f zerrrq.f zerrtr.f zerrtz.f
   zgbt01.f zgbt02.f zgbt05.f zgeqls.f
   zgerqs.f zget01.f zget02.f
   zget03.f zget04.f zget07.f zgtt01.f zgtt02.f
   zgtt05.f zhet01.f zhet01_rook.f zhet01_3.f
   zhet01_aa.f
   zhpt01.f zlaipd.f zlaptm.f zlarhs.f zlatb4.f zlatb5.f
   zlatsp.f zlatsy.f zlattb.f zlattp.f zlattr.f
   zlavhe.f zlavhe_rook.f zlavhp.f zlavsp.f zlavsy.f zlavsy_rook.f zlqt01.f
   zlqt02.f zlqt03.f zpbt01.f zpbt02.f zpbt05.f
   zpot01.f zpot02.f zpot03.f zpot05.f zpst01.f
   zppt01.f zppt02.f zppt03.f zppt05.f zptt01.f
   zptt02.f zptt05.f zqlt01.f zqlt02.f zqlt03.f
   zqpt01.f zqrt01.f zqrt01p.f zqrt02.f zqrt03.f zqrt11.f
   zqrt12.f zqrt13.f zqrt14.f zqrt15.f zqrt16.f
   zqrt17.f zrqt01.f zrqt02.f zrqt03.f zrzt01.f zrzt02.f
   zsbmv.f  zspt01.f
   zspt02.f zspt03.f zsyt01.f zsyt01_rook.f zsyt01_3.f
   zsyt01_aa.f
   zsyt02.f zsyt03.f
   ztbt02.f ztbt03.f ztbt05.f ztbt06.f ztpt01.f
   ztpt02.f ztpt03.f ztpt05.f ztpt06.f ztrt01.f
   ztrt02.f ztrt03.f ztrt05.f ztrt06.f
   dget06.f zgennd.f
   zqrt04.f zqrt05.f zchkqrt.f zerrqrt.f zchkqrtp.f zerrqrtp.f
   zchklqt.f zchklqtp.f zchktsqr.f
   zerrlqt.f zerrlqtp.f zerrtsqr.f ztsqr01.f zlqt04.f zlqt05.f
   zchkunhr_col.f zerrunhr_col.f zunhr_col01.f zunhr_col02.f)

if(USE_XBLAS)
  list(APPEND ZLINTST zdrvgbx.f zdrvgex.f zdrvhex.f zdrvsyx.f zdrvpox.f
                      zerrvxx.f zerrgex.f zerrhex.f zerrsyx.f zerrpox.f
                      zebchvxx.f)
else()
  list(APPEND ZLINTST zdrvgb.f zdrvge.f zdrvhe.f zdrvsy.f zdrvpo.f
                      zerrvx.f zerrge.f zerrhe.f zerrsy.f zerrpo.f)
endif()

set(DSLINTST dchkab.f
	ddrvab.f ddrvac.f derrab.f derrac.f dget08.f
	alaerh.f alahd.f  aladhd.f alareq.f
	chkxer.f dlarhs.f dlatb4.f xerbla.f
	dget02.f dpot06.f)

set(ZCLINTST zchkab.f
	zdrvab.f zdrvac.f zerrab.f zerrac.f zget08.f
	alaerh.f alahd.f  aladhd.f alareq.f
	chkxer.f zget02.f zlarhs.f zlatb4.f
	zsbmv.f  xerbla.f zpot06.f zlaipd.f)

set(SLINTSTRFP schkrfp.f sdrvrfp.f sdrvrf1.f sdrvrf2.f sdrvrf3.f sdrvrf4.f serrrfp.f
	slatb4.f slarhs.f sget04.f spot01.f spot03.f spot02.f
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(DLINTSTRFP dchkrfp.f ddrvrfp.f ddrvrf1.f ddrvrf2.f ddrvrf3.f ddrvrf4.f derrrfp.f
	dlatb4.f dlarhs.f dget04.f dpot01.f dpot03.f dpot02.f
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(CLINTSTRFP cchkrfp.f cdrvrfp.f cdrvrf1.f cdrvrf2.f cdrvrf3.f cdrvrf4.f cerrrfp.f
  claipd.f clatb4.f clarhs.f csbmv.f cget04.f cpot01.f cpot03.f cpot02.f
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(ZLINTSTRFP zchkrfp.f zdrvrfp.f zdrvrf1.f zdrvrf2.f zdrvrf3.f zdrvrf4.f zerrrfp.f
  zlatb4.f zlaipd.f zlarhs.f zsbmv.f zget04.f zpot01.f zpot03.f zpot02.f
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

macro(add_lin_executable name)
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} openblas${SUFFIX64_UNDERSCORE})
#${TMGLIB} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
endmacro()

if(BUILD_SINGLE)
  add_lin_executable(xlintsts ${ALINTST} ${SLINTST} ${SCLNTST})
  add_lin_executable(xlintstrfs ${SLINTSTRFP})
endif()

if(BUILD_DOUBLE)
  add_lin_executable(xlintstd ${ALINTST} ${DLINTST} ${DZLNTST})
  add_lin_executable(xlintstrfd ${DLINTSTRFP})
endif()

if(BUILD_SINGLE AND BUILD_DOUBLE)
  add_lin_executable(xlintstds ${DSLINTST})
endif()

if(BUILD_COMPLEX)
  add_lin_executable(xlintstc ${ALINTST} ${CLINTST} ${SCLNTST})
  add_lin_executable(xlintstrfc ${CLINTSTRFP})
endif()

if(BUILD_COMPLEX16)
  add_lin_executable(xlintstz ${ALINTST} ${ZLINTST} ${DZLNTST})
  add_lin_executable(xlintstrfz ${ZLINTSTRFP})
endif()

if(BUILD_COMPLEX AND BUILD_COMPLEX16)
  add_lin_executable(xlintstzc ${ZCLINTST})
endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Jürgen Pfeifer <juergen@familiepfeifer.de>

_realname=OpenBLAS
pkgbase=mingw-w64-openblas
pkgname=("${MINGW_PACKAGE_PREFIX}-openblas"
         $([[ "${CARCH}" == "i686" ]] || echo "${MINGW_PACKAGE_PREFIX}-openblas64"))
pkgver=0.3.26
pkgrel=1
pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
url="https://www.openblas.net/"
msys2_repository_url="https://github.com/OpenMathLib/OpenBLAS"
msys2_references=(
  'archlinux: openblas'
)
license=('spdx:BSD-3-Clause')
provides=("${MINGW_PACKAGE_PREFIX}-${_realname}")
conflicts=("${MINGW_PACKAGE_PREFIX}-openblas-git")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}"
          "${MINGW_PACKAGE_PREFIX}-${_realname}-git")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-fc")
             "dos2unix")
options=('!buildflags')
source=(https://github.com/OpenMathLib/OpenBLAS/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz
        002-lgfortran-requires-lquadmath.patch
        004-aarch64-detection.patch
        005-fix-pkgconfig-files.patch)
sha256sums=('4e6e4f5cb14c209262e33e6816d70221a2fe49eb69eaf0a06f065598ac602c68'
            'c147ec053bdf0387d499372472365aa829db0d8200b6828b0ebce5209e8603fd'
            '70ce007ff4f6c2a127f9835ce9cd85081707cf3bcccddcfaa06817b06f69c941'
            'bb36b75624fe9768d3d16e9d824e79d4dea5b0f0056601ca4ce37bc93e46f4b5')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    002-lgfortran-requires-lquadmath.patch \
    004-aarch64-detection.patch \
    005-fix-pkgconfig-files.patch
}

_build_openblas() {
  _idx_opt=$1

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _extra_config+=("-DC_LAPACK=ON")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    # Clang wasn't able to compile all the kernels inside the arm64 folder,
    # Enable only the cores known to run Windows on ARM
    _extra_config+=("-DTARGET=CORTEXA53")
    _extra_config+=("-DDYNAMIC_LIST=\"ARMV8 CORTEXA53 CORTEXA55 CORTEXA57 CORTEXA72 CORTEXA73 CORTEXA510 CORTEXA710 CORTEXX1 CORTEXX2\"")
  else
    _extra_config+=("-DTARGET=CORE2")
    _extra_config+=("-DDYNAMIC_ARCH=ON")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_STATIC_LIBS=ON \
    -DUSE_THREAD=ON \
    -DNUM_THREADS=64 \
    -DUSE_OPENMP=ON \
    -DQUIET_MAKE=ON \
    "${_extra_config[@]}" \
    ${_idx_opt} \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}-32" && cd "${srcdir}/build-${MSYSTEM}-32"

  msg2 "Build OpenBLAS with 32-bit indexing"
  _build_openblas ""

  if [ "${CARCH}" != "i686" ]; then
    mkdir -p "${srcdir}/build-${MSYSTEM}-64" && cd "${srcdir}/build-${MSYSTEM}-64"

    msg2 "Build OpenBLAS with 64-bit indexing"
    _build_openblas "-DBINARY=64 -DINTERFACE64=1"
  fi
}

check() {
  cd "${srcdir}"/build-${MSYSTEM}-32
  ctest

  if [ "${CARCH}" != "i686" ]; then
    cd "${srcdir}/build-${MSYSTEM}-64"
    ctest
  fi
}

package_openblas() {
  pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas (mingw-w64)"

  cd "${srcdir}"/build-${MSYSTEM}-32

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  # Install License
  install -Dm0644 ${srcdir}/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
  install -Dm0644 ${srcdir}/${_realname}-${pkgver}/lapack-netlib/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE-lapack
}

package_openblas64() {
  pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas with 64-bit indexing (mingw-w64)"
  provides=()
  conflicts=()
  replaces=()

  cd "${srcdir}"/build-${MSYSTEM}-64

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  # Install License
  install -Dm0644 ${srcdir}/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}64/LICENSE
  install -Dm0644 ${srcdir}/${_realname}-${pkgver}/lapack-netlib/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}64/LICENSE-lapack
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
